Package com.collibra.dgc.core.api.component.query.outputmodule

# Interface OutputModuleApi

public interface OutputModuleApi
Contains all api operations of Output Module.

The Output Module is a lightweight graph query engine. It allows many different output formats (json, xml, excel, csv, ...) and provides a one stop API to query most of DGC's entities (assets, communities, domains, types, ...) using SQL-like filtering capabilities. The query engine also supports sorting of entities using any of the available properties as well as paging of the results. Last but not least, the query engine also honors view permissions that were set for the particular logged in user that is issuing the REST call. Please refer to Output Module documentation for mode details.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `exportCSV(ExportCSVRequest request)`
  Performs an Output Module query and exports the returns results immediately in CSV format.
  `Job`
  `exportCSVInJob(ExportCSVInJobRequest request)`
  Starts a job that performs an Output Module query and stores the results in a file in CSV format.
  `FileInfo`
  `exportCSVToFile(ExportCSVToFileRequest request)`
  Performs an Output Module query and stores the query results in a file in CSV format.
  `void`
  `exportCSVToStream(ExportCSVRequest request, OutputStream outputStream)`
  Performs an Output Module query and streams the results to Response immediately in CSV format .
  `Job`
  `exportExcelInJob(ExportExcelInJobRequest request)`
  Starts a job that performs an Output Module query and stores the results in a file in Excel format.
  `FileInfo`
  `exportExcelToFile(ExportExcelToFileRequest request)`
  Performs an Output Module query and stores the query results in a file in Excel format.
  `String`
  `exportJSON(ExportJSONRequest request)`
  Performs an Output Module query and exports the returns results immediately in JSON format.
  `Job`
  `exportJSONInJob(ExportJSONInJobRequest request)`
  Starts a job that performs an Output Module query and stores the results in a file in JSON format.
  `FileInfo`
  `exportJSONToFile(ExportJSONToFileRequest request)`
  Performs an Output Module query and stores the query results in a file in JSON format.
  `void`
  `exportJSONToStream(ExportJSONRequest request, OutputStream outputStream)`
  Performs an Output Module query and streams the results to Response immediately in JSON format .
  `String`
  `exportXML(ExportXMLRequest request)`
  Performs an Output Module query and exports the returns results immediately in XML format.
  `Job`
  `exportXMLInJob(ExportXMLInJobRequest request)`
  Starts a job that performs an Output Module query and stores the results in a file in XML format.
  `FileInfo`
  `exportXMLToFile(ExportXMLToFileRequest request)`
  Performs an Output Module query and stores the query results in a file in XML format.

- ## Method Details

  - ### exportCSV

    @SecurityAuditMethod(resultFormatter=com.collibra.audit.formatter.StringLengthFormatter.class) String exportCSV(ExportCSVRequest request)
    Performs an Output Module query and exports the returns results immediately in CSV format.
    Parameters:
      `request` - the properties of the request
    Returns:
      the string response in CSV format

  - ### exportCSVToStream

    @SecurityAuditMethod(resultFormatter=com.collibra.audit.formatter.StringLengthFormatter.class) void exportCSVToStream(ExportCSVRequest request, OutputStream outputStream)
    Performs an Output Module query and streams the results to Response immediately in CSV format .
    Parameters:
      `request` - the properties of the request
      `outputStream` - CSV response data streamed to OutputStream

  - ### exportCSVInJob

    Job exportCSVInJob(ExportCSVInJobRequest request)
    Starts a job that performs an Output Module query and stores the results in a file in CSV format. Id of the file can be retrieved from the `message.id` property of the job once the job is finished.
    Parameters:
      `request` - the properties of the request
    Returns:
      the job that performs an Output Module query

  - ### exportCSVToFile

    FileInfo exportCSVToFile(ExportCSVToFileRequest request)
    Performs an Output Module query and stores the query results in a file in CSV format. The id of the file is returned in the response.
    Parameters:
      `request` - the properties of the request
    Returns:
      the information about the file where the results are stored

  - ### exportExcelInJob

    Job exportExcelInJob(ExportExcelInJobRequest request)
    Starts a job that performs an Output Module query and stores the results in a file in Excel format. Id of the file can be retrieved from the `message.id` property of the job once the job is finished.
    Parameters:
      `request` - the properties of the request
    Returns:
      the job that performs an Output Module query

  - ### exportExcelToFile

    FileInfo exportExcelToFile(ExportExcelToFileRequest request)
    Performs an Output Module query and stores the query results in a file in Excel format. The id of the file is returned in the response.
    Parameters:
      `request` - the properties of the request
    Returns:
      the information about the file where the results are stored

  - ### exportJSON

    @SecurityAuditMethod(resultFormatter=com.collibra.audit.formatter.StringLengthFormatter.class) String exportJSON(ExportJSONRequest request)
    Performs an Output Module query and exports the returns results immediately in JSON format.
    Returns:
      the string response in JSON format

  - ### exportJSONToStream

    @SecurityAuditMethod(resultFormatter=com.collibra.audit.formatter.StringLengthFormatter.class) void exportJSONToStream(ExportJSONRequest request, OutputStream outputStream)
    Performs an Output Module query and streams the results to Response immediately in JSON format .
    Parameters:
      `request` - the properties of the request
      `outputStream` - JSON response data streamed to OutputStream

  - ### exportJSONInJob

    Job exportJSONInJob(ExportJSONInJobRequest request)
    Starts a job that performs an Output Module query and stores the results in a file in JSON format. Id of the file can be retrieved from the `message.id` property of the job once the job is finished.
    Parameters:
      `request` - the properties of the request
    Returns:
      the job that performs an Output Module query

  - ### exportJSONToFile

    FileInfo exportJSONToFile(ExportJSONToFileRequest request)
    Performs an Output Module query and stores the query results in a file in JSON format. The id of the file is returned in the response.
    Parameters:
      `request` - the properties of the request
    Returns:
      the information about the file where the results are stored

  - ### exportXML

    @SecurityAuditMethod(resultFormatter=com.collibra.audit.formatter.StringLengthFormatter.class) String exportXML(ExportXMLRequest request)
    Performs an Output Module query and exports the returns results immediately in XML format.
    Returns:
      the string response in XML format

  - ### exportXMLInJob

    Job exportXMLInJob(ExportXMLInJobRequest request)
    Starts a job that performs an Output Module query and stores the results in a file in XML format. Id of the file can be retrieved from the `message.id` property of the job once the job is finished.
    Parameters:
      `request` - the properties of the request
    Returns:
      the job that performs an Output Module query

  - ### exportXMLToFile

    FileInfo exportXMLToFile(ExportXMLToFileRequest request)
    Performs an Output Module query and stores the query results in a file in XML format. The id of the file is returned in the response.
    Parameters:
      `request` - the properties of the request
    Returns:
      the information about the file where the results are stored